VERSION 5.00
Begin VB.Form frmDriveInfo 
   Caption         =   "Form2"
   ClientHeight    =   4545
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8175
   LinkTopic       =   "Form2"
   ScaleHeight     =   4545
   ScaleWidth      =   8175
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.TextBox txtInfo 
      BackColor       =   &H8000000A&
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1455
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   2415
   End
End
Attribute VB_Name = "frmDriveInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
   Icon = frmMain.Icon
   Caption = "Extended drive info"
End Sub

Public Sub GetExtendedInfo(ByVal driveidx As Long)
   Dim di As DRIVE_INFO
   Dim sInfo As String
   Dim sType As String, s As String
   Dim lSize As Long, i As Long, j As Long
   Dim iSet(3) As Long
   Dim curSize As Currency
   
   di = GetDriveInfo(driveidx)
   sType = DeviceType(di.GenConfig)
   sInfo = "GENERAL CONFIGURATION INFO:"
   sInfo = sInfo & vbCrLf & "  Controler                    : " & IIf(driveidx < 2, "Primary", "Secondary")
   sInfo = sInfo & vbCrLf & "  Drive                        : " & IIf(driveidx Mod 2, "Slave", "Master")
   sInfo = sInfo & vbCrLf & "  Protocol type                : " & sType
   sInfo = sInfo & vbCrLf & "  Device is removable          : " & CBool(di.GenConfig And &H80)
   If di.GenConfig And &H4 Then
      sInfo = sInfo & vbCrLf & ">>>>>Incomplete responce!<<<<<"
      GoTo InfoError
   End If
   sInfo = sInfo & vbCrLf & "  Logical cylinders            : " & Format(vbIntToUShort(di.Cilinders), "###,###,##0")
   sInfo = sInfo & vbCrLf & "  Logical heads                : " & vbIntToUShort(di.Heads)
   sInfo = sInfo & vbCrLf & "  Logical sectors per track    : " & vbIntToUShort(di.SectorsPerTrack)
   sInfo = sInfo & vbCrLf & "  Model                        : " & Trim(di.ModelNumber)
   sInfo = sInfo & vbCrLf & "  Serial Number                : " & Trim(di.SerialNumber)
   sInfo = sInfo & vbCrLf & "  Firmware version             : " & Trim(di.FirmWare)
   sInfo = sInfo & vbCrLf
   sInfo = sInfo & vbCrLf & "  ECC bytes available  for READ/WRITE LONG       : " & di.ECCSize
   sInfo = sInfo & vbCrLf & "  Max sectors transfer for READ/WRITE MULTIPLE   : " & (di.MoreVendorUnique And &HFF)
   
   If sType = "ATAPI" Then
      sInfo = sInfo & vbCrLf & ATAPI_INFO(di.GenConfig)
   End If
   
   sInfo = sInfo & vbCrLf & vbCrLf & "CURRENT LOGICAL PARAMETERS:"
   sInfo = sInfo & vbCrLf & "  Cylinders                    : " & Format(vbIntToUShort(di.NumCurrentCyls), "###,###,##0")
   sInfo = sInfo & vbCrLf & "  Heads                        : " & vbIntToUShort(di.NumCurrentHeads)
   sInfo = sInfo & vbCrLf & "  Sectors per track            : " & vbIntToUShort(di.NumCurrentSectorsPerTrack)
   curSize = 0
   CopyMemory curSize, di.CurrentSectorCapacity(0), 4
   sInfo = sInfo & vbCrLf & "  CHS   mode capacity (sectors): " & Format(curSize * 10000, "###,###,###,##0") & " (" & FormatByteSize(curSize * 5120000#) & ")"
   curSize = 0
   CopyMemory curSize, di.TotalAddressableSectors(0), 4
   sInfo = sInfo & vbCrLf & "  LBA   mode capacity (sectors): " & Format(curSize * 10000, "###,###,###,##0") & " (" & FormatByteSize(curSize * 5120000#) & ")"
   curSize = 0
   CopyMemory curSize, di.MaxUserLBA48(0), 8
   If curSize > 0 Then
      sInfo = sInfo & vbCrLf & "  LBA48 mode capacity (sectors): " & Format(curSize * 10000, "###,###,###,##0") & " (" & FormatByteSize(curSize * 5120000#) & ")"
   End If
   
   sInfo = sInfo & vbCrLf
   If (di.MultSectorStuff And &H100) Then
      sInfo = sInfo & vbCrLf & "  Current sectors transfer for READ/WRITE MULTIPLE : " & (di.MoreVendorUnique And &HFF)
   Else
      sInfo = sInfo & vbCrLf & "  Current sectors transfer for READ/WRITE MULTIPLE : " & (di.MoreVendorUnique And &HFF)
   End If
   
   sInfo = sInfo & vbCrLf & vbCrLf & "FUTURES:"
   sInfo = sInfo & vbCrLf & "  Standby timer values         : " & IIf(di.Capabilities And &H2000, "Standard", "Device specific")
   sInfo = sInfo & vbCrLf & "  LBA mode                     : " & IIf(di.Capabilities And &H100, "Supported", "Not supported")
   sInfo = sInfo & vbCrLf & "  DMA mode                     : " & IIf(di.Capabilities And &H200, "Supported", "May be supported")
   sInfo = sInfo & vbCrLf & "  IORDY                        : " & IIf(di.Capabilities And &H800, "Supported", "Not supported")
   sInfo = sInfo & vbCrLf & "  IORDY can be disabled        : " & CBool(di.Capabilities And &H400)
   
   sInfo = sInfo & vbCrLf & vbCrLf & "DMA/PIO MODES AVAILABLE:"
   If di.SingleWordDMA Then
      For i = 0 To 7
         If IsBitSetInt(di.SingleWordDMA, i) Then
            sInfo = sInfo & vbCrLf & "       Singleword DMA mode " & CStr(i)
            If IsBitSetInt(di.SingleWordDMA, i + 8) Then
               iSet(0) = i
            End If
         End If
      Next i
      sInfo = sInfo & vbCrLf
   End If
   If di.MultiWordDMA Then
      For i = 0 To 7
         If IsBitSetInt(di.MultiWordDMA, i) Then
            sInfo = sInfo & vbCrLf & "       Multiword DMA mode " & CStr(i)
            If IsBitSetInt(di.MultiWordDMA, i + 8) Then
               iSet(1) = i
            End If
         End If
      Next i
      sInfo = sInfo & vbCrLf
   End If
   If di.UltraDMA Then
      For i = 0 To 7
         If IsBitSetInt(di.UltraDMA, i) Then
            sInfo = sInfo & vbCrLf & "       Ultra DMA mode " & CStr(i)
            If IsBitSetInt(di.UltraDMA, i + 8) Then
               iSet(2) = i
            End If
         End If
      Next i
      sInfo = sInfo & vbCrLf
   End If
   If di.AdvancedPIOMode Then
      sInfo = sInfo & vbCrLf & "       PIO mode 2"
      For i = 0 To 7
         If IsBitSetInt(di.AdvancedPIOMode, i) Then
            sInfo = sInfo & vbCrLf & "       Advance PIO mode " & CStr(i + 3)
         End If
      Next i
      sInfo = sInfo & vbCrLf
   Else
      sInfo = sInfo & vbCrLf & "       PIO mode 1"
   End If
   If iSet(0) Then sInfo = sInfo & vbCrLf & "  Current active DMA mode: Singleword DMA mode " & CStr(iSet(0))
   If iSet(1) Then sInfo = sInfo & vbCrLf & "  Current active DMA mode: Multiword DMA mode " & CStr(iSet(1))
   If iSet(2) Then sInfo = sInfo & vbCrLf & "  Current active DMA mode: Ultra DMA mode " & CStr(iSet(2))
   
   sInfo = sInfo & vbCrLf
   sInfo = sInfo & vbCrLf & "  Minimum Multiword DMA transfer cycle time per word           : " & di.MinDMATime & " ns."
   sInfo = sInfo & vbCrLf & "  Manufacturers recommended Multiword DMA transfer cycle time : " & di.RecommendDMATime & " ns."
   sInfo = sInfo & vbCrLf & "  Minimum PIO transfer cycle time without flow control         : " & di.MinPIOTime & " ns."
   sInfo = sInfo & vbCrLf & "  Minimum PIO transfer cycle time with IORDY flow control      : " & di.MinPIOTimeIORDY & " ns."
   
   sInfo = sInfo & vbCrLf & vbCrLf & "PROTOCOL STANDARDS:"
   For i = 1 To 14
       If IsBitSetInt(di.MajorVersion, i) Then
          s = s & " ATA-" & CStr(i) & ";"
       End If
   Next i
   sInfo = sInfo & vbCrLf & "   Supported:" & Left(s, Len(s) - 1)
   If di.MinorVersion Then
      sInfo = sInfo & vbCrLf & "   Current version: " & MinorATAVersion(di.MinorVersion)
   End If
   sInfo = sInfo & vbCrLf & vbCrLf & "COMMANDS/FUTURES:"
   sInfo = sInfo & vbCrLf & "  ENABLED   SUPPORTED"
   For i = 0 To 15
      If IsBitSetInt(di.CommandSetSupported(0), i) Then
         s = ""
         Select Case i
                Case 0:  s = "S.M.A.R.T"
                Case 1:  s = "Security Mode"
                Case 2:  s = "Removable Media"
                Case 3:  s = "Power Management"
                Case 5:  s = "Write cache"
                Case 6:  s = "Look-ahead"
                Case 7:  s = "RELEASE interrupt"
                Case 8:  s = "SERVICE interrupt"
                Case 9:  s = "DEVICE RESET"
                Case 10: s = "Host Protected Area"
                Case 11: s = "WRITE VERIFY command"
                Case 12: s = "WRITE BUFFER command"
                Case 13: s = "READ BUFFER command"
                Case 14: s = "NOP command"
                Case 15: s = "Identify Device DMA command"
         End Select
         If IsBitSetInt(di.CommandSetEnabled(0), i) Then
            s = "+      " & s
         Else
            s = "       " & s
         End If
         sInfo = sInfo & vbCrLf & "     " & s
      End If
   Next i
   For i = 0 To 13
      If IsBitSetInt(di.CommandSetSupported(1), i) Then
         s = ""
         Select Case i
                Case 0:  s = "DOWNLOAD MICROCODE command"
                Case 1:  s = "READ/WRITE DMA QUEUED"
                Case 2:  s = "CFA"
                Case 3:  s = "Advanced Power Management"
                Case 4:  s = "Removable Media Status Notification"
                Case 5:  s = "Power-Up In Standby"
                Case 6:  s = "SET FEATURES subcommand required to spinup after power-up"
                Case 8:  s = "SET MAX security extension"
                Case 9:  s = "Automatic acoustic management"
                Case 10: s = "48-bit Address"
                Case 11: s = "Device Configuration Overlay"
                Case 12: s = "Mandatory FLUSH CACHE command"
                Case 13: s = "FLUSH CACHE EXT command"
                Case Else: s = "Unknown future 1_" & CStr(i)
         End Select
         If IsBitSetInt(di.CommandSetEnabled(1), i) Then
            s = "+      " & s
         Else
            s = "       " & s
         End If
         sInfo = sInfo & vbCrLf & "     " & s
      End If
   Next i
   For i = 0 To 13
      If IsBitSetInt(di.CommandSetSupported(2), i) Then
         s = ""
         Select Case i
                Case 0:  s = "S.M.A.R.T error logging"
                Case 1:  s = "S.M.A.R.T self-test"
                Case 2:  s = "Media serial number"
                Case 3:  s = "Media Card Pass Through Command"
                Case 5:  s = "General Purpose Logging"
                Case 4:  s = "Streaming"
                Case 6:  s = "WRITE DMA FUA EXT and WRITE MULTIPLE FUA EXT commands"
                Case 7:  s = "WRITE DMA QUEUED FUA EXT command"
                Case 8:  s = "64-bit World wide name"
                Case 9:  s = "URG bit for READ STREAM DMA EXT and READ STREAM EXT"
                Case 10: s = "URG bit for WRITE STREAM DMA EXT and WRITE STREAM EXT"
                Case 11: s = "Reserved for technical report"
                Case 12: s = "Reserved for technical report"
                Case 13: s = "IDLE IMMEDIATE with UNLOAD FEATURE supported"
                Case Else: s = "Unknown future 2_" & CStr(i)
         End Select
         If IsBitSetInt(di.CommandSetEnabled(2), i) Then
            s = "+      " & s
         Else
            s = "       " & s
         End If
         sInfo = sInfo & vbCrLf & "     " & s
      End If
   Next i
   sInfo = sInfo & vbCrLf & vbCrLf & "SECURITY: "
   If (di.SecurityStatus And 1) Then
      sInfo = sInfo & "Supported"
      sInfo = sInfo & vbCrLf & "   Security enabled                   : " & YesNoBoolean(IsBitSetInt(di.SecurityStatus, 1))
      sInfo = sInfo & vbCrLf & "   Security locked                    : " & YesNoBoolean(IsBitSetInt(di.SecurityStatus, 2))
      sInfo = sInfo & vbCrLf & "   Security frozen                    : " & YesNoBoolean(IsBitSetInt(di.SecurityStatus, 3))
      sInfo = sInfo & vbCrLf & "   Security count expired             : " & YesNoBoolean(IsBitSetInt(di.SecurityStatus, 4))
      If di.SecurityEraseTime Then
         sInfo = sInfo & vbCrLf & "   Security erase supported           : Yes"
         sInfo = sInfo & vbCrLf & "      Time required for security erase unit completion     : " & di.SecurityEraseTime & " min."
      Else
         sInfo = sInfo & vbCrLf & "   Security erase supported           : No"
      End If
      If IsBitSetInt(di.SecurityStatus, 5) Then
         sInfo = sInfo & vbCrLf & "   Enhanced security erase supported  : Yes"
         sInfo = sInfo & vbCrLf & "      Time required for Enhanced security erase completion : " & di.EnhSecurityEraseTime & " min."
      Else
         sInfo = sInfo & vbCrLf & "   Enhanced security erase supported  : No"
      End If
      sInfo = sInfo & vbCrLf & "   Security level                     : " & IIf(IsBitSetInt(di.SecurityStatus, 8), "Maximum", "High")
      sInfo = sInfo & vbCrLf & "   Master code                        : 0x" & Hex(di.MasterPassword)
   Else
      sInfo = sInfo & "Not supported"
   End If
   sInfo = sInfo & vbCrLf & vbCrLf & "ACOUSTIC MANAGEMENT: "
   If di.AcousticData Then
      sInfo = sInfo & "Supported"
      sInfo = sInfo & vbCrLf & "   Vendors recommended acoustic management value : " & HIBYTE(di.AcousticData)
      sInfo = sInfo & vbCrLf & "   Current automatic acoustic management value    : " & LOBYTE(di.AcousticData)
      sInfo = sInfo & vbCrLf & "   Inter-seek delay for ISO-7779 acoustic testing : " & di.InterSeekDelay & " mksec."
   Else
      sInfo = sInfo & "Not supported"
   End If
   sInfo = sInfo & vbCrLf & vbCrLf & "STREAMING: "
   If di.StreamTransferTimeDMA Then
      sInfo = sInfo & "Supported"
      sInfo = sInfo & vbCrLf & "   Stream Minimum Request Size            : " & di.StreamMinRequestSize
      sInfo = sInfo & vbCrLf & "   Streaming Transfer Time - DMA          : " & di.StreamTransferTimeDMA
      sInfo = sInfo & vbCrLf & "   Streaming Transfer Time - PIO          : " & di.StreamTransferTimePIO
      sInfo = sInfo & vbCrLf & "   Streaming Access Latency - DMA and PIO : " & di.StreamAccessLatency
      curSize = 0
      CopyMemory curSize, di.StreamPerfGranularity(0), 4
      sInfo = sInfo & vbCrLf & "   Streaming Performance Granularity      : " & curSize * 10000
   Else
      sInfo = sInfo & "Not supported"
   End If
InfoError:
   txtInfo = sInfo
End Sub

Private Function DeviceType(ByVal GenConfig As Integer) As String
   If GenConfig = &H858A Then
      DeviceType = "COMPACT FLASH"
   Else
      If (GenConfig And &HC000) = &H8000 Then
         DeviceType = "ATAPI"
      ElseIf (GenConfig And &H8000) = 0 Then
         DeviceType = "ATA"
      Else
         DeviceType = "Unknown"
      End If
   End If
End Function

Private Function ATAPI_INFO(ByVal GenConfig As Integer) As String
   Dim s As String, sInfo As String
   Dim ATAPI_DEVICE_TYPE As Long
   Dim ATAPI_DRQ_TYPE As Long
   Dim ATAPI_Packet_Size As Long
   sInfo = sInfo & vbCrLf & "  ATAPI info:"
   ATAPI_DEVICE_TYPE = RShift(GenConfig And &H1F00, 8)
   Select Case ATAPI_DEVICE_TYPE
          Case 0: s = "Direct-access Device"
          Case 1: s = "Streaming Tape Device"
          Case 5: s = "CD-ROM Device"
          Case 7: s = "Optical memory Device"
          Case 31: s = "Unknown or no Device type"
          Case Else: s = "Reserved"
   End Select
   sInfo = sInfo & vbCrLf & "  Device type                   : " & s
   ATAPI_DRQ_TYPE = RShift(GenConfig And &H60, 5)
   Select Case ATAPI_DRQ_TYPE
          Case 0: s = "Microprocessor DRQ"
          Case 1: s = "Interrupt DRQ"
          Case 2: s = "Accelerated DRQ"
          Case Else: s = "Reserved"
   End Select
   sInfo = sInfo & vbCrLf & "  Command Packet DRQ Type       : " & s
   Select Case (GenConfig And &H3)
          Case 0: s = "12 bytes"
          Case 1: s = "16 bytes"
          Case Else: s = "Reserved"
   End Select
   sInfo = sInfo & vbCrLf & "  Command Packet size           : " & s
End Function

Private Function MinorATAVersion(ByVal ver As Integer) As String
   Select Case ver
          Case &H1:  MinorATAVersion = "ATA (ATA-1) X3T9.2 781D prior to revision 4"
          Case &H2:  MinorATAVersion = "ATA-1 published, ANSI X3.221-1994"
          Case &H3:  MinorATAVersion = "ATA (ATA-1) X3T9.2 781D revision 4"
          Case &H4:  MinorATAVersion = "ATA-2 published, ANSI X3.279-1996"
          Case &H5:  MinorATAVersion = "ATA-2 X3T10 948D prior to revision 2k"
          Case &H6:  MinorATAVersion = "ATA-3 X3T10 2008D revision 1"
          Case &H7:  MinorATAVersion = "ATA-2 X3T10 948D revision 2k"
          Case &H8:  MinorATAVersion = "ATA-3 X3T10 2008D revision 0"
          Case &H9:  MinorATAVersion = "ATA-2 X3T10 948D revision 3"
          Case &HA:  MinorATAVersion = "ATA-3 published, ANSI X3.298-1997"
          Case &HB:  MinorATAVersion = "ATA-3 X3T10 2008D revision 6"
          Case &HC:  MinorATAVersion = "ATA-3 X3T13 2008D revision 7"
          Case &HD:  MinorATAVersion = "ATA/ATAPI-4 X3T13 1153D revision 6"
          Case &HE:  MinorATAVersion = "ATA/ATAPI-4 T13 1153D revision 13"
          Case &HF:  MinorATAVersion = "ATA/ATAPI-4 X3T13 1153D revision 7"
          Case &H10: MinorATAVersion = "ATA/ATAPI-4 T13 1153D revision 18"
          Case &H11: MinorATAVersion = "ATA/ATAPI-4 T13 1153D revision 15"
          Case &H12: MinorATAVersion = "ATA/ATAPI-4 published, ANSI INCITS 317-1998"
          Case &H13: MinorATAVersion = "ATA/ATAPI-5 T13 1321D revision 3"
          Case &H14: MinorATAVersion = "ATA/ATAPI-4 T13 1153D revision 14"
          Case &H15: MinorATAVersion = "ATA/ATAPI-5 T13 1321D revision 1"
          Case &H16: MinorATAVersion = "ATA/ATAPI-5 published, ANSI INCITS 340-2000"
          Case &H17: MinorATAVersion = "ATA/ATAPI-4 T13 1153D revision 17"
          Case &H18: MinorATAVersion = "ATA/ATAPI-6 T13 1410D revision 0"
          Case &H19: MinorATAVersion = "ATA/ATAPI-6 T13 1410D revision 3a"
          Case &H1A: MinorATAVersion = "ATA/ATAPI-7 T13 1532D revision 1"
          Case &H1B: MinorATAVersion = "ATA/ATAPI-6 T13 1410D revision 2"
          Case &H1C: MinorATAVersion = "ATA/ATAPI-6 T13 1410D revision 1"
          Case &H1D: MinorATAVersion = "Reserved"
          Case &H1E: MinorATAVersion = "ATA/ATAPI-7 T13 1532D revision 0"
          Case &H1F: MinorATAVersion = "Reserved"
          Case &H20: MinorATAVersion = "Reserved"
          Case &H21: MinorATAVersion = "ATA/ATAPI-7 T13 1532D revision 4a"
          Case &H22: MinorATAVersion = "ATA/ATAPI-6 published, ANSI INCITS 361-2002"
          Case Else: MinorATAVersion = "Reserved"
   End Select
End Function

Private Function YesNoBoolean(ByVal bVal As Boolean) As String
   If bVal Then YesNoBoolean = "Yes" Else YesNoBoolean = "No"
End Function
Private Sub Form_Resize()
   If WindowState = vbMinimized Then Exit Sub
   txtInfo.Move 0, 0, ScaleWidth, ScaleHeight
End Sub
