Attribute VB_Name = "mMisc"
Option Explicit

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (LpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function StrFormatByteSize Lib "Shlwapi" Alias "StrFormatByteSizeW" (ByVal dw As Currency, ByVal pszBuf As Long, ByVal cchBuf As Long) As Long
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long

Public Function IsWindowsNT() As Boolean
   Dim verinfo As OSVERSIONINFO
   verinfo.dwOSVersionInfoSize = Len(verinfo)
   If (GetVersionEx(verinfo)) = 0 Then Exit Function
   If verinfo.dwPlatformId = 2 Then IsWindowsNT = True
End Function

Public Function IsBitSetByte(ByVal iBitString As Byte, ByVal lBitNo As Integer) As Boolean
    If lBitNo = 7 Then
        IsBitSetByte = iBitString < 0
    Else
        IsBitSetByte = iBitString And (2 ^ lBitNo)
    End If
End Function

Public Function IsBitSetInt(ByVal iBitString As Integer, ByVal lBitNo As Integer) As Boolean
    If lBitNo = 15 Then
        IsBitSetInt = iBitString < 0
    Else
        IsBitSetInt = iBitString And (2 ^ lBitNo)
    End If
End Function

Public Function IsBitSetLong(ByVal iBitString As Integer, ByVal lBitNo As Integer) As Boolean
    If lBitNo = 31 Then
        IsBitSetLong = iBitString < 0
    Else
        IsBitSetLong = iBitString And (2 ^ lBitNo)
    End If
End Function

Public Function SwapStringBytes(ByVal sIn As String) As String
   Dim sTemp As String
   Dim i As Integer
   sTemp = Space(Len(sIn))
   For i = 1 To Len(sIn) - 1 Step 2
       Mid(sTemp, i, 1) = Mid(sIn, i + 1, 1)
       Mid(sTemp, i + 1, 1) = Mid(sIn, i, 1)
   Next i
   SwapStringBytes = sTemp
End Function

Public Function TrimNull(startstr As String) As String
   Dim pos As Integer
   pos = InStr(startstr, Chr$(0))
   If pos Then
      TrimNull = Left$(startstr, pos - 1)
      Exit Function
   End If
   TrimNull = startstr
End Function

Public Function FormatByteSize(ByVal Bytes As Currency) As String
   Dim strBuff As String * 256
   Dim nRet As Long
   nRet = StrFormatByteSize(Bytes / 10000, StrPtr(strBuff), 256)
   If nRet Then FormatByteSize = Ptr2StrU(nRet)
End Function

Private Function Ptr2StrU(ByVal pAddr As Long) As String
   Dim lAddr As Long: lAddr = lstrlenW(pAddr)
   Ptr2StrU = Space$(lAddr)
   CopyMemory ByVal StrPtr(Ptr2StrU), ByVal pAddr, lAddr * 2
End Function

Public Function HexZeroPad(ByVal lVal As Long, ByVal iLength As Long) As String
   HexZeroPad = Right(String(iLength, "0") & Hex(lVal), iLength)
End Function

Public Function vbIntToUShort(vbInt As Integer) As Long
   If vbInt < 0 Then
      vbIntToUShort = vbInt + &H10000
   Else
      vbIntToUShort = CLng(vbInt)
   End If
End Function

Public Function LShift(ByVal lValue As Long, ByVal lNumberOfBitsToShift As Long) As Long
    LShift = lValue * (2 ^ lNumberOfBitsToShift)
End Function

Public Function RShift(ByVal lValue As Long, ByVal lNumberOfBitsToShift As Long) As Long
    RShift = lValue \ (2 ^ lNumberOfBitsToShift)
End Function

Public Function HIBYTE(ByVal wParam As Integer) As Integer
    CopyMemory HIBYTE, ByVal VarPtr(wParam) + 1, 1
End Function

Public Function LOBYTE(ByVal wParam As Integer) As Integer
    CopyMemory LOBYTE, wParam, 1
End Function
